function out1 = MOD2( IMO )
%Aggregation based on nodes and modification of the reserves power based on
%an incident for their maximum/minimum capacity
IMO(:,1:3)=IMO(:,1:3)/20000000; %18155000; % Division by the Sbase so that Power is in pu
load('Power_schedule.mat')
load('Resources_connectivity.mat');
PS=Power_schedule{:,:};
PS(:,1:2)=PS(:,1:2)/20000000; %18155000; % Division by the Sbase so that Power is in pu
RC=Resources_connectivity{:,:};
sz1=size(PS);
sz2=size(IMO);
Pp(1:max(RC(:,2)))=0;
Pn(1:max(RC(:,2)))=0;
Q(1:max(RC(:,2)))=0;

MOL_Augmented=[IMO 0*IMO(:,4)];

for j=1:sz2(1)
     for i=1:sz1(1)
         if(RC(i,1)==IMO(j,4))
            MOL_Augmented(j,5)=RC(i,2);
         end
     end
 end
for i=1:sz1(1)
    Pp(RC(i,2))=Pp(RC(i,2))+PS(i,1);
    Pn(RC(i,2))=Pn(RC(i,2))+PS(i,1);
    Q(RC(i,2))=Q(RC(i,2))+PS(i,2); 
end

 sz2=size(IMO);
 for j=1:sz2(1)
     for i=1:sz1(1)
         if(RC(i,1)==IMO(j,4))
            Pp(RC(i,2))=Pp(RC(i,2))+IMO(j,1)-IMO(j,3);
            Pn(RC(i,2))=Pn(RC(i,2))-IMO(j,3)+IMO(j,2);
         end
     end
 end
 
%Construction of Ybus
load('Grid_Data.mat');
Grid_data=Grid_Data{:,:};
Grid_data(:,4)=Grid_data(:,4)/(20+0j); %22; %Calculation of pu impedances 
sz=size(Grid_data);
numbuses=max(max(Grid_data(:,2),max(Grid_data(:,3))));
for m=1:sz(1)
    Y1(m,1)=1/Grid_data(m,4);
    Y1(m,2)=Grid_data(m,2);
    Y1(m,3)=Grid_data(m,3);
end
Ybus(numbuses, numbuses)=0+0j;
for k=1:numbuses
    for l=1:numbuses
        if (k==l)
%             Ybus(k, l)=0;
            for m=1:sz(1)
                if (Y1(m,2)==k||Y1(m,3)==k)
                    Ybus(k,l)=Ybus(k,l)+Y1(m,1);
                end
            end
        else
            for m=1:sz(1)
                if((Y1(m,2)==k||Y1(m,2)==l)&&(Y1(m,3)==k||Y1(m,3)==l))
                    Ybus(k,l)=-Y1(m,1);
                end
            end
        end
    end
end

%Specification of system parameters
sz4=size(RC);

for i=1:sz4(1)
    Bus_Type(RC(i,2))=RC(i,3);
end

Delta_P(numbuses)=0;
Delta_Q(numbuses)=0;
Q_spec=Q;


%Calculation of admittances' angles and magnitudes

for m=1:numbuses
    for n=1:numbuses
        g(m,n)=angle(Ybus(m,n));
        Y(m,n)=abs(Ybus(m,n));
    end
end
step=1;

%Initiation of bus voltages
while(step<3)
V=[1 1 1 1 1 1];
d=[0 0 0 0 0 0];
if (step==1)
    P_spec=Pp;
else
    P_spec=Pn;
end

for counter=1:15
%Calculation of DP(n) and DQ(n)

for i=1:numbuses
    if (Bus_Type(i)==1)
        A=0;
        B=0;
        for j=1:numbuses
            A=A+V(j)*(Y(i,j))*cos(d(j)-d(i)+g(i,j));
            B=B+V(j)*(Y(i,j))*sin(d(j)-d(i)+g(i,j));
        end
        Delta_P(i)=P_spec(i)-V(i)*A;
        Delta_Q(i)=Q_spec(i)+V(i)*B;

    elseif (Bus_Type(i)==2)
        A=0;
        for j=1:numbuses
            A=A+V(j)*(Y(i,j))*cos(d(j)-d(i)+g(i,j));
        end
       Delta_P(i)=P_spec(i)-V(i)*A;

    end
end

%Calculation of matrices H, M, N and L for all buses
for i=1:numbuses
    for j=1:numbuses
        if (i~=j)
             H_init(i,j)=-V(i)*V(j)*(Y(i,j))*sin(d(j)-d(i)+g(i,j));
             N_init(i,j)=V(i)*(Y(i,j))*cos(d(j)-d(i)+g(i,j));
             M_init(i,j)=-V(i)*V(j)*(Y(i,j))*cos(d(j)-d(i)+g(i,j));
             L_init(i,j)=-V(i)*(Y(i,j))*sin(d(j)-d(i)+g(i,j));
             
        else
            H_init(i,i)=0;
            N_init(i,i)=2*V(i)*(Y(i,i))*cos(g(i,i));
            M_init(i,i)=0;
            L_init(i,i)=-2*V(i)*(Y(i,i))*sin(g(i,i));
            for k=1:numbuses
                if (i~=k)
                    H_init(i,i)=H_init(i,i)+V(i)*V(k)*(Y(i,k))*sin(d(k)-d(i)+g(i,k));
                    N_init(i,i)=N_init(i,i)+V(k)*(Y(i,k))*cos(d(k)-d(i)+g(i,k));
                    M_init(i,i)=M_init(i,i)+V(i)*V(k)*(Y(i,k))*cos(d(k)-d(i)+g(i,k));
                    L_init(i,i)=L_init(i,i)-V(k)*(Y(i,k))*sin(d(k)-d(i)+g(i,k));
                end
            end
        end
    end
end

%Calculation of final H, M, N and L matrices taking into account slack and
%generation buses

%Calculation of H
k=1;
l=1;
for i=1:numbuses
    if(Bus_Type(i)~=0)
        for j=1:numbuses
            if(Bus_Type(j)~=0)
                H(l,k)=H_init(i,j);
                k=k+1;
            end
        end
    k=1;
    l=l+1;
    end
end

%Calculation of N
k=1;
l=1;
for i=1:numbuses
    if(Bus_Type(i)~=0)
        for j=1:numbuses
            if(Bus_Type(j)==1)
                N(l,k)=N_init(i,j);
                k=k+1;
            end
        end
    k=1;
    l=l+1;
    end
end

%Calculation of M
k=1;
l=1;
for i=1:numbuses
    if(Bus_Type(i)==1)
        for j=1:numbuses
            if(Bus_Type(j)~=0)
                M(l,k)=M_init(i,j);
                k=k+1;
            end
        end
    k=1;
    l=l+1;
    end
end

%Calculation of L
k=1;
l=1;
for i=1:numbuses
    if(Bus_Type(i)==1)
        for j=1:numbuses
            if(Bus_Type(j)==1)
                L(l,k)=L_init(i,j);
                k=k+1;
            end
        end
    k=1;
    l=l+1;
    end
end

%Calculation of JACOBIAN matrix
JACOBIAN=[H N;M L];

%Calculation only of the necessary Delta P and Delta Q taking into account
%slack bus and generation buses
k=1;
for i=1:numbuses
    if (Bus_Type(i)~=0)
        D_P(k)=Delta_P(i);
        k=k+1;
    end
end

k=1;
for i=1:numbuses
    if (Bus_Type(i)==1)
        D_Q(k)=Delta_Q(i);
        k=k+1;
    end
end
D_PQ=[D_P D_Q];
D_dV=inv(JACOBIAN)*D_PQ';

k=1;
for i=1:numbuses
    if (Bus_Type(i)~=0)
        d(i)=d(i)+D_dV(k);
        k=k+1;
    end
end
for i=1:numbuses
    if (Bus_Type(i)==1)
        V(i)=V(i)+D_dV(k);
        k=k+1;
    end
end
end

%Calculation of P(i) and Q(i)

for i=1:numbuses
    if (Bus_Type(i)==0)
        A=0;
        B=0;
        for j=1:numbuses
            A=A+V(j)*(Y(i,j))*cos(d(j)-d(i)+g(i,j));
            B=B+V(j)*(Y(i,j))*sin(d(j)-d(i)+g(i,j));
        end
        P_spec(i)=V(i)*A;
        Q_spec(i)=-V(i)*B;

    elseif (Bus_Type(i)==2)
        B=0;
        for j=1:numbuses
            B=B+V(j)*(Y(i,j))*sin(d(j)-d(i)+g(i,j));
        end
       Q_spec(i)=-V(i)*B;

    end
end
imag=0+1i;
for m=1:numbuses
    V_complex(m)=V(m)*cos(d(m))+V(m)*sin(d(m))*imag;
end

for m=1:numbuses
    for n=1:numbuses
        if (n~=m)
           S(m,n)=V_complex(m)*(conj(V_complex(m))-conj(V_complex(n)))*conj(-Ybus(m,n));
        else S(m,n)=0;
        end
    end
end

%Voltages are checked and if they are outside specific limits the reserves
%of the corresponding buses become zero
if(step==1)
    for i=1:numbuses
        if(V(i)>1.1)
            for j=1:sz2(1)
                if(MOL_Augmented(j,5)==i)
                    MOL_Augmented(j,1)=MOL_Augmented(j,3);
                end
            end
        end
    end
elseif(step==2)
      for i=1:numbuses
        if(V(i)<0.9)
            for j=1:sz2(1)
                if(MOL_Augmented(j,5)==i)
                    MOL_Augmented(j,2)=MOL_Augmented(j,3);
                end
            end
        end
      end  
end

step=step+1;
IMO=MOL_Augmented(:,1:4);
end
IMO(:,1:3)=IMO(:,1:3)*20000000; %18155000; % Recalculation of powers in Watts
out1=IMO;

end

